/* The Waffle Cookie Press                                                 */
/* Version 1.61                                                            */

/* By Christopher Horn (chorn@eastwind.mcds.com)                           */
/* Compiled 9/10/92 under Borland C/C++ 3.0                                */

/* This program is hereby released to the public domain. As freeware, it   */
/* may not be sold or leased in any form. Furthermore, the author makes    */
/* no claims as to it's suitability for use, and is not liable concerning  */
/* it's use, on any machine other than his own.                            */

/* The Cookie Press is a replacement cookie utility for Waffle.            */
/* It supports multiline cookies and anonymous sigs.                       */

#include<stdio.h>
#include<time.h>
#include<stdlib.h>
#include<string.h>
#include<conio.h>

                        /* Defines for special characters                  */

#define BS     8                                 /* Backspace              */
#define EM     25                                /* Ctrl-Y  (Delete line)  */
#define LF     10                                /* Line Feed              */
#define CR     13                                /* Carriage Return        */
#define SPACE  32                                /* Space                  */

                        /* Global variables                                */

char cookie[20][76];                   /* To hold the entered cookie       */
char uacct[8];                         /* User account                     */
int usec;                              /* User security level              */
char uname[30];                        /* User identity                    */

char fname[100];                       /* Filename                         */
FILE *fp;                              /* Our file pointer                 */
int i,j;                               /* Loop variables                   */
int cpos;                              /* Lines in entered cookie          */
char tmp[80], tmp2[80];                /* Work string                      */
time_t dt;                             /* Structure to get date            */
char cdt[12];                          /* The current date                 */
char ch;                               /* Work char                        */

char syspath[80]="c:/waffle/system/";  /* Path to Waffle system directory  */
char admpath[80]="c:/waffle/admin/";   /* Path to Waffle admin directory   */
char hlppath[80]="c:/waffle/text/";    /* Path to Waffle text directory    */
char fwn[8] = "cookies";               /* Default work file name           */
int climit = 2;                        /* Line limit for cookie            */
int cadd = 1;                          /* Security to add cookie           */
int canon = 5;                         /* Security to make anonymous       */
int cdate = 0;                         /* Add date to signature            */
int clog = 0;                          /* Write to admin log               */
int ccheck = 0;                        /* Check if really want entered     */
long timeout = 120;                    /* Inactivity time out in seconds   */
char cprompt[80] = "Enter cookie, but no bufu...";
char crem[80] = "Spoilsport. No cookie for you.";
char cask[80] = "Toss the cookie into the cookie jar?";

                        /* Function prototypes                             */

void dispcook(void);                   /* Display a cookie                 */
void getcook(void);                    /* Get a cookie                     */
void getcnf(char *st);                 /* Get configuration info           */
void clist(int num);                   /* List cookies                     */
void chelp(void);                      /* Display help file                */
int ccount(FILE *stream);              /* Get number of cookies            */
void frerr(void);                      /* File read error                  */
void fwerr(void);                      /* File write error                 */
int getstr(char *st, int maxlen);      /* Get a string                     */
void gobye(void);                      /* Inactivity exit                  */


int main(int argc, char *argv[])
{
  if (argc<5)		/* Someone forgot to call with the arguements	   */
  {
    printf("\nThe Waffle Cookie Press"
           "\nVersion 1.61\n"
           "\nCommand line syntax :"
           "\n  COOKIE <config path> O %A %a [%i] %W\n"
           "\nWhere :"
           "\n  <config path> is the path to the config file"
           "\n  %A is the user account"
           "\n  %a is the access level"
           "\n  %i is the extra argument data"
           "\n  %W is the user identity\n\n");
    exit(0);
  }                                    /* Start getting config info        */
  printf("\n\n");
  getcnf(argv[1]);

  strupr(argv[4]);                     /* Check for extended arguments     */
  if (!strcmp(argv[4],"[HELP]")) chelp();
  if (!strcmp(argv[4],"[?]")) chelp();
  if (!strcmp(argv[4],"[LIST]")) clist(0);
  if (!strcmp(argv[4],"[JAR]")) clist(0);
  if ((i = atoi(argv[4]+1)) != 0) clist(i);

  strcpy(uacct,argv[2]);               /* Get account name		   */
  usec = atoi(argv[3]);		       /* Get level			   */
  strcpy(uname,"");
  for(i=5; i<argc; i++)                /* Get identity                     */
  {
    strcat(uname,argv[i]);
    if (i != argc-1) strcat(uname," ");
  }

  dt = time(NULL);                     /* Get current date                 */
  strcpy(tmp,ctime(&dt));
  strncpy(cdt,tmp+8,2);
  strcat(cdt,"-");
  strncat(cdt,tmp+4,3);
  strcat(cdt,"-");
  strncat(cdt,tmp+22,2);

  dispcook();                          /* Display a cookie                 */
  if (usec >= cadd) getcook();         /* Get a cookie                     */
  printf("\n");
  return(0);
}


/*-------------------------------------------------------------------------*/
/* dispcook  Display a cookie                                              */

void dispcook(void)
{
  strcpy(fname,syspath);
  strcat(fname,fwn);
  if((fp = fopen(fname,"r")) == NULL) return;
  i = ccount(fp);

  randomize();
  i = random(i);
  for(j=0; j<i; j++)
  {
    if (fscanf(fp,"%[^|]",cookie) == EOF) return;
    ch = getc(fp);
  }

  do {
    ch = getc(fp);
    if (ch == '|') break;
    putchar(ch);
  } while (!feof(fp));

  fclose(fp);
  printf("\n");
}


/*-------------------------------------------------------------------------*/
/* getcook  Get a cookie                                                   */

void getcook(void)
{
  printf("\n%s",cprompt);
  for(cpos=0; cpos < climit; cpos++)
  {
    printf("\n");
    if((!getstr(cookie[cpos],75))) break;
  }
  if (!cpos)
  {
    printf("\n\n%s\n",crem);
    return;
  }
  if (ccheck)
  {
    printf("\n\n%s ",cask);
    getstr(tmp,3);
    if (toupper(tmp[0]) != 'Y') return;
  }
  if (usec < canon)
  {
    strcpy(cookie[cpos],"                                   [");
    strcat(cookie[cpos],uname);
    if (cdate)
    {
      strcat(cookie[cpos],",");
      strcat(cookie[cpos],cdt);
    }
    strcat(cookie[cpos],"]");
  } else cpos--;

  if ((fp = fopen(fname,"a"))==NULL) fwerr();
  for (i=0; i<=cpos; i++)
  {
    fprintf(fp,"%s",cookie[i]);
    if (i < cpos) fprintf(fp,"\n");
  }
  fprintf(fp,"|\n");
  fclose(fp);

  if (!clog) return;
  strcpy(fname,admpath);
  strcat(fname,fwn);
  if ((fp = fopen(fname,"a"))==NULL) fwerr();
  fprintf(fp,"\n");
  for (i=0; i<=cpos; i++)
  {
    fprintf(fp,"%s",cookie[i]);
    if (i < cpos) fprintf(fp,"\n");
  }
  fprintf(fp,"|\n%s (%s)\n",uacct,uname);
  fclose(fp);
}


/*-------------------------------------------------------------------------*/
/* getcnf  Get configuration info if a config file exists		   */

void getcnf(char *st)
{
  strcpy(fname,st);
  if((fp = fopen(fname,"r")) == NULL) return;
  while(!feof(fp))
  {
    fscanf(fp,"%[^\n]",tmp);
    if ((i = getc(fp)) == EOF) break;
    strcpy(tmp2,tmp);
    strupr(tmp);
    if(!strncmp("SYSPATH=",tmp,8)) strcpy(syspath,tmp2+8);
    if(!strncmp("ADMPATH=",tmp,8)) strcpy(admpath,tmp2+8);
    if(!strncmp("HLPPATH=",tmp,8)) strcpy(hlppath,tmp2+8);
    if(!strncmp("FORMAT=",tmp,7)) strcpy(fwn,tmp2+7);
    if(!strncmp("PROMPT=",tmp,7)) strcpy(cprompt,tmp2+7);
    if(!strncmp("REM=",tmp,4)) strcpy(crem,tmp2+4);
    if(!strncmp("ASK=",tmp,4)) strcpy(cask,tmp2+4);
    if(!strncmp("LIMIT=",tmp,6))
      if((climit = atoi(tmp+6)) < 1) climit = 1;
        else if(climit > 18) climit = 18;
    if(!strncmp("ANON=",tmp,5))
      if((canon = atoi(tmp+5)) < 0) canon = 0;
        else if(canon > 9) canon = 9;
    if(!strncmp("ADD=",tmp,4))
      if((cadd = atoi(tmp+4)) < 0) cadd = 0;
        else if(cadd > 9) cadd = 9;
    if(!strncmp("LOG=",tmp,4))
      if(toupper(tmp[4]) == 'Y') clog = 1;
    if(!strncmp("CHECK=",tmp,6))
      if(toupper(tmp[6]) == 'Y') ccheck = 1;
    if(!strncmp("DATE=",tmp,5))
      if(toupper(tmp[5]) == 'Y') cdate = 1;
    if(!strncmp("TIME=",tmp,5))
      if((timeout = atol(tmp+5)) < 30) timeout = 30;
  }
  fclose(fp);
}


/*-------------------------------------------------------------------------*/
/* clist  Cookie list                                                      */

void clist(int num)
{
  if (num < 0) exit(0);
  strcpy(fname,syspath);
  strcat(fname,fwn);
  if((fp = fopen(fname,"r")) == NULL) frerr();
  if (num > 0)
  {
    i = ccount(fp);
    if (num < i)
    {
      i = i-num-1;
      for(j=0; j<i; j++)
      {
        fscanf(fp,"%[^|]",cookie);
        ch = getc(fp);
      }
    }
  }

  i = 1;
  while (fscanf(fp,"%[^\n|]",tmp) != EOF)
  {
    if ((ch = getc(fp)) == EOF) break;
    if (ch == '|')
    {
      if (strlen(tmp) > 0) strncpy(tmp,tmp,strlen(tmp)-1);
      strcat(tmp,"\n");
      ++i;
      if (getc(fp) == EOF) break;
    }
    printf("%s\n",tmp);
    if (++i > 22)
    {
      printf("[more]");
      getch();
      printf("\b \b\b \b\b \b\b \b\b \b\b \b");
      i = 1;
    }
  }
  fclose(fp);
  printf("\n");
  exit(0);
}


/*-------------------------------------------------------------------------*/
/* chelp Display help screen if asked for                                  */

void chelp(void)
{
  strcpy(fname,hlppath);
  strcat(fname,fwn);
  strcat(fname,".hlp");
  if ((fp = fopen(fname,"r"))!=NULL)
  {
    while((i = getc(fp))!=EOF)
    {
      switch(i)
      {
	case 12:
	  while(getch()!=13);
	  break;
	case 126:
	  j = getc(fp);
	  if (j == 42) for(i=0; i<25; i++) printf("\n");
	  break;
	default:
	  putchar(i);
      }
    }
    fclose(fp);
  } else printf("\n\nSorry, no help is available at this time.\n\n");
  exit(0);
}


/*-------------------------------------------------------------------------*/
/* ccount  Return number of cookies in file                                */

int ccount(FILE *fh)
{
   int tot = 0;
   do
   {
     if ((fscanf(fh,"%[^|]",cookie)) == EOF) break;
     tot++;
     if (getc(fh) == EOF) break;
   } while (1);
   rewind(fh);
   return tot;
}


/*-------------------------------------------------------------------------*/
/* frerr  Report a file open for read i/o error and abort program	   */

void frerr(void)
{
  printf("\n\n\nError : Unable to open %s for reading\n\n",fname);
  exit(0);
}


/*-------------------------------------------------------------------------*/
/* fwerr  Report file open for write i/o error and abort program           */

void fwerr(void)
{
  printf("\n\n\nError : Unable to open %s for writing\n\n",fname);
  exit(0);
}


/*-------------------------------------------------------------------------*/
/* getstr  Gets a string from the user. Can only be maxlen long. Ctrl-H    */
/* is backspace, Ctrl-Y clears the line.				   */

int getstr(char *st,int maxlen)
{
  int lp, len, ch;
  clock_t start;

  for (lp=0; lp<maxlen+1; lp++) putchar(SPACE);
  putchar(93);
  lp++;
  for (; lp>0; lp--) putchar(BS);
  putchar(91);
  len = 0;

  start = clock();
  while(!kbhit())
    if((clock() - start) > timeout*CLK_TCK) gobye();
  ch = getch();

  while ((ch!=CR) && (ch!=LF) && (ch!=EOF))
  {
    if (ch==BS)          	        /* Handle backspace                */
    {
      if(len>0)
      {
	len--;
	st--;
	putchar(BS);
	putchar(SPACE);
	putchar(BS);
      }
    }
    else
    if (ch==EM)			        /* Handle delete line              */
    {
      for(; len>0; len--)
      {
	st--;
	putchar(BS);
	putchar(SPACE);
	putchar(BS);
      }
    }
    else
    if (len < maxlen)
    {                             	/* Good character, put in string   */
      *st++ = ch;
      len++;
      putchar(ch); 			/* And display it		   */
    }
    start = clock();
    while(!kbhit())
      if((clock() - start) > timeout*CLK_TCK) gobye();
    ch = getch();
  }
  *st=0;                                /* Terminate the string       	   */
  return len;				/* Return the length		   */
}


void gobye(void)
{
  fcloseall();
  printf("\n\nError : Inactivity forced a time out\n");
  exit(1);
}
